<template>
    <div class="legend-element mb-2"
      v-if="layer.isLegendDisplayed && layer.isLayerVisible() && !layer.baseLayer">
        <h2 class="mb-0 legend-header" v-b-toggle="'collapse' + layer.id">
            {{ layer.title }}
        </h2>

        <b-collapse :id="'collapse' + layer.id" class="mt-2" :appear="true" :visible="true">
            <div class="container_legend">
                <span v-if="layer.type === 'WMS'">
                    <img :src="legendUrl" :alt="'légende de la couche '+layer.title">
                </span>
                <span v-if="layer.type === 'WMTS'">
                    Pas de légende
                </span>
                <div
                  v-if="layer.type === 'VectorTile'
                    || layer.type === 'Vector'
                    || layer.type === 'WFS'">
                    <VectorLegend :layer="layer"></VectorLegend>

                </div>
                <span v-if="layer.type === 'OSM'">
                    Pas de légende
                </span>
            </div>
        </b-collapse>
    </div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import LayerConfig from '@/models/map-context/LayerConfig';
import Component from 'vue-class-component';
import VectorLegend from '@/components/plugins/legend/VectorLegend.vue';
import BaseComponent from '../../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    VectorLegend,
  },
})
export default class LayerLegend extends BaseComponent {
  layer!:LayerConfig;

  legendUrl='';

  mounted() {
    this.legendUrl = this.layer.getLegendImageUrl();
    const maxUrlLength = 2000;
    if (this.legendUrl.length < maxUrlLength) {
      return;
    }
    const client = new XMLHttpRequest();
    const urlArray = this.legendUrl.split('?');
    const url = urlArray[0];
    const params = urlArray[1];
    client.open('POST', url, true);
    // eslint-disable-next-line @typescript-eslint/no-this-alias
    const self = this;
    client.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
    client.responseType = 'arraybuffer';

    client.onload = function onload() {
      const arrayBufferView = new Uint8Array(this.response);
      const blob = new Blob([arrayBufferView], { type: 'image/png' });
      const urlCreator = window.URL || (window as any).webkitURL;
      const imageUrl = urlCreator.createObjectURL(blob);
      self.legendUrl = imageUrl;
    };
    client.addEventListener('error', (e) => {
      console.log('erreur');
    });
    client.send(params);
  }

  getLegendImageUrl() {
    return this.layer.getLegendImageUrl();
  }
}
</script>

<style scoped lang="less">
@import "../../../styles/variables.less";
.legend-header{
    border-bottom: 3px solid @grey;
    font-size: 15px !important;
    line-height: 30px;
    color: @second;
    font-weight: 600;
}
.legend-header:hover{
    background-color: @light-grey;
}
.container_legend{
    padding: 2px 0px;
}
</style>
